<%- include("partials/header") %>

    <!-- Modal -->
    <div class="modal fade" id="chatModal" tabindex="-1" role="dialog" aria-labelledby="chatModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-lg" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <div class="modal-title chat-modal-title" id="chatModalLabel">
              <img src="" class="d-inline-block rounded-circle">
              <h5 class="d-inline-block mb-0 mx-2"></h5>
            </div>
            <button type="button" class="close mr-auto ml-0" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body p-0">
            <div class="chat-history p-3"></div>
            <form class="chat-form p-3" onsubmit="sendMessage(event);" dir="ltr">
              <div class="input-group">
                <div class="input-group-append">
                  <div class="input-group-text border-0">
                    <button type="submit" class="send-message-button border-0">
                      <i class="fas fa-paper-plane"></i>
                    </button>
                  </div>
                </div>
                <input type="text" class="form-control chat-input text-right" placeholder="پیام" dir="rtl">
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>

    <section class="notifs-messages-dashboard py-4 px-4">
      <div class="row">
        <div class="col-2">
          <div class="nav flex-column text-right p-0 nav-pills" id="notifs-messages-tab" role="tablist" aria-orientation="vertical">
            <a class="nav-link active" id="notifs-messages-notifs-tab" data-toggle="pill" href="#notifs" role="tab" aria-controls="notifs" aria-selected="true">اطلاعیه‌ها</a>
            <a class="nav-link" id="notifs-messages-messages-tab" data-toggle="pill" href="#messages" role="tab" aria-controls="messages" aria-selected="false">پیام‌ها</a>
          </div>
        </div>
        <div class="col-10">
          <div class="tab-content" id="notifs-messages-tabContent">
            <div class="tab-pane fade show active" id="notifs" role="tabpanel" aria-labelledby="notifs-messages-notifs-tab">
              <% if (pageData.userNotifs.length == 0) { %>
                <h5 class="text-center">شما اطلاعیه‌ای ندارید.</h5>
              <% } else { %>
                <% for (i = 0; i < pageData.userNotifs.length; i++ ) { %>
                  <div class="d-none user-notif">
                    <%= pageData.userNotifs[i].notif_id %>
                  </div>
                  <% if (pageData.userNotifs[i].dismissable == "true") { %>
                    <div class="alert alert-success alert-dismissable fade show text-right dashboard-notif-item" role="alert" dir="ltr" id="notif<%= pageData.userNotifs[i].notif_id %>">
                      <button type="button" class="close ml-2" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                      </button>
                  <% } else { %>
                    <div class="alert alert-success text-right dashboard-notif-item" role="alert" dir="ltr">
                  <% } %>
                    <h4 class="alert-heading">
                      <%= pageData.userNotifs[i].title %>
                    </h4>
                    <p><%= pageData.userNotifs[i].content %></p>
                  </div>
                <% } %>
              <% } %>
            </div>
            <div class="tab-pane fade" id="messages" role="tabpanel" aria-labelledby="notifs-messages-messages-tab">
              <div class="messages-panel my-3">
                <div class="row m-0">
                  <% if (pageData.chats.length == 0) { %>
                    <h5 class="text-center">شما پیامی ندارید.</h5>
                  <% } else { %>
                    <% for (i = 0; i < pageData.chats.length; i++ ) { %>
                      <div class="dashboard-message-list-item rounded col-5 mx-4 mb-4 p-2" id="user1" onclick="openChatModal(event, '<%= pageData.chats[i].otherUserData.username %>');">
                        <div class="name-and-time">
                          <h6 class="float-right"><%= pageData.chats[i].otherUserData.first_name %> <%= pageData.chats[i].otherUserData.last_name %></h6>
                          <h6 class="float-left"><%= pageData.chats[i].chatData.messages.slice(-1).time.toString().slice(16, 21) %></h6>
                          <div class="clearfix"></div>
                        </div>
                        <div class="message-and-unread">
                          <p class="float-right text-muted m-0 chat-last-message-gist"><%= pageData.chats[i].chatData.messages.slice(-1).text %></p>
                          <% if (pageData.chats[i].unreadMessages > 0) { %>
                            <span class="float-left badge badge-danger rounded-circle"><%= pageData.chats[i].unreadMessages %></span>
                          <% } %>
                          <div class="clearfix"></div>
                        </div>
                      </div>
                    <% } %>
                  <% } %>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>

    <%- include("partials/footer") %>

    <script>
      var userNotifsRaw = $(".user-notif");
      var userNotifs = [];
      var activeChatUser = 0;
      var activeChat = 0;

      if (userNotifsRaw.length > 0) {
        for (i = 0; i < userNotifsRaw.length; i++) {
          userNotifs.push($(userNotifsRaw[i]).text().trim());
        }
      }

      if (userNotifs.length > 0) {
        for (i = 0; i < userNotifs.length; i++) {
          $("#notif" + userNotifs[i]).on("close.bs.alert", function (e) {
            dismissNotif(e.target.id.slice(5));
          })
        }
      }

      function dismissNotif (id) {
        var noNotifMessage = `<h5 class="text-center">شما اطلاعیه‌ای ندارید.</h5>`;

        $.ajax({
          method: "POST",
          url: "/dismissnotif",
          dataType: "json",
          data: {
            notif_id: id
          },

          success: function (data) {
            console.log("POST REQUEST SUCCESSFUL");
            console.log(data);

            if ($(".alert").length == 0) {
              $("#notifs").empty();
              $("#notifs").append(noNotifMessage);
            }
          },

          error: function (err) {
            console.log("POST REQUEST ERROR");
            console.log(err);
          }
        });
      }

      setInterval(function () {
        console.log("UPDATE INTERVAL CALLED");

        var notifs = $("#notifs");
        var chats = $(".messages-panel .row");
        var chatHistory = $(".chat-history");
        var notifTemp = ``;
        var chatTemp = ``;
        var messageTemp = ``;
        var lastOrder;

        $.ajax({
          method: "POST",
          url: "/updatemn",
          dataType: "json",
          data: {},

          success: function (data) {
            console.log("UPDATE POST REQUEST SUCCESSFUL");
            console.log(data);

            if (data.notifs.length > 0) {
              notifs.empty()

              for (i = 0; i < data.notifs.length; i++) {
                if (data.notifs[i].dismissable == "true") {
                  notifTemp += `<div class="alert alert-success alert-dismissable fade show text-right dashboard-notif-item" role="alert" dir="ltr" id="notif${data.notifs[i].notif_id}"><button type="button" class="close ml-2" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>`
                } else {
                  notifTemp += `<div class="alert alert-success text-right dashboard-notif-item" role="alert" dir="ltr">`
                }

                notifTemp += `<h4 class="alert-heading">${data.notifs[i].title}</h4><p>${data.notifs[i].content}</p></div>`

                notifs.append(notifTemp);

                notifTemp = ``;
              }
            }

            if (data.messages.length > 0) {
              chats.empty()

              for (i = 0; i < data.messages.length; i++) {
                chatTemp = `<div class="dashboard-message-list-item rounded col-5 mx-4 mb-4 p-2" id="user1" onclick="openChatModal(event, '${data.messages[i].otherUserData.username}');"><div class="name-and-time"><h6 class="float-right">${data.messages[i].otherUserData.first_name} ${data.messages[i].otherUserData.last_name}</h6><h6 class="float-left">${data.messages[i].chatData.messages.slice(-1).time.toString().slice(16, 21)}</h6><div class="clearfix"></div></div><div class="message-and-unread"><p class="float-right text-muted m-0 chat-last-message-gist">${data.messages[i].chatData.messages.slice(-1).text}</p>`

                if (parseInt(data.messages[i].unreadMessages) > 0) {
                  chatTemp = chatTemp + `<span class="float-left badge badge-danger rounded-circle">${data.messages[i].unreadMessages}</span>`;
                }

                chatTemp = chatTemp + `<div class="clearfix"></div></div></div>`

                chats.append(chatTemp);

                chatTemp = ``;

                if (data.messages[i].otherUserData.username == activeChatUser) {
                  lastOrder = parseInt(chatHistory.children().last().attr("messageorder"));
                  for (j = 0; j < data.messages[i].chatData.messages.length; i++) {
                    if (parseInt(data.messages[i].chatData.messages[j].order) > lastOrder) {
                      if (data.chat.messages[i].chatData.messages[j].sender == userId) {
                        messageTemp = `<div class="chat-message-parent w-100 my-1" messageorder="${data.chat.messages[i].chatData.messages[j].order}"><div class="chat-message p-1 rounded text-right float-left"><h6 class="m-0">${data.chat.messages[i].chatData.messages[j].text}</h6><p class="text-muted small m-0">${data.chat.messages[i].chatData.messages[j].time.toString().slice(16, 21)}</p></div><div class="clearfix"></div></div>`
                        chatHistory.append(messageTemp)
                      } else {
                        messageTemp = `<div class="chat-message-parent chat-me-message-parent w-100 my-1" messageorder="${data.chat.messages[i].chatData.messages[j].order}"><div class="chat-message p-1 rounded text-right"><h6 class="m-0">${data.chat.messages[i].chatData.messages[j].text}</h6><p class="m-0 text-muted small">${data.chat.messages[i].chatData.messages[j].time.toString().slice(16, 21)}</p></div></div>`
                        chatHistory.append(messageTemp)
                      }
                    }

                    messageTemp = ``;
                  }
                }
              }
            }
          },

          error: function (err) {
            console.log("UPDATE POST REQUEST ERROR");
            console.log(err);
          }
        })
      }, 1000 * 60 * 5)

      function openChatModal (e, userId) {
        var chatTitle = $(".chat-modal-title h5");
        var chatImg = $(".chat-modal-title img");
        var chatHistory = $(".chat-history");
        var messageTemp = ``;

        chatHistory.empty();

        $.ajax({
          method: "POST",
          url: "/getchat",
          dataType: "json",
          data: {
            receiver_id: userId
          },

          success: function (data) {
            console.log("GET CHAT POST REQUEST SUCCESSFUL");
            console.log(data);

            for (i = 0; i < data.chat.messages.length; i++) {
              if (data.chat.messages[i].sender == userId) {
                messageTemp = `<div class="chat-message-parent w-100 my-1" messageorder="${data.chat.messages[i].order}"><div class="chat-message p-1 rounded text-right float-left"><h6 class="m-0">${data.chat.messages[i].text}</h6><p class="text-muted small m-0">${data.chat.messages[i].time.toString().slice(16, 21)}</p></div><div class="clearfix"></div></div>`
                chatHistory.append(messageTemp)
              } else {
                messageTemp = `<div class="chat-message-parent chat-me-message-parent w-100 my-1" messageorder="${data.chat.messages[i].order}"><div class="chat-message p-1 rounded text-right"><h6 class="m-0">${data.chat.messages[i].text}</h6><p class="m-0 text-muted small">${data.chat.messages[i].time.toString().slice(16, 21)}</p></div></div>`
                chatHistory.append(messageTemp)
              }

              messageTemp = ``;
            }

            activeChatUser = userId;
            activeChat = data.chat.chat_id;
          },

          error: function (err) {
            console.log("GET CHAT POST REQUEST ERROR");
            console.log(err);
          }
        })

        $("#chatModal").modal("show");
      }

      $("chatModal").on("hide.bs.modal", function (e) {
        console.log("MODAL CLosing");
        activeChat = 0;
        activeChatUser = 0;
      })

      function sendMessage (e) {
        console.log("SEND MESSAGE CALLED");

        e.preventDefault();

        var chatHistory = $(".chat-history");
        var chatInput = $(".chat-form input");
        var messageTemp = ``;

        $.ajax({
          method: "POST",
          url: "/sendmessage",
          dataType: "json",
          data: {
            chat_id: activeChat,
            text: chatInput.val()
          },

          success: function (data) {
            console.log("SEND MESSAGE POST REQUEST SUCCESSFUL");
            console.log(data);

            messageTemp = `<div class="chat-message-parent chat-me-message-parent w-100 my-1" messageorder="${data.messageOrder}"><div class="chat-message p-1 rounded text-right"><h6 class="m-0">${chatInput.val()}</h6><p class="m-0 text-muted small">${Date().toString().slice(16, 21)}</p></div></div>`

            chatHistory.append(messageTemp)

            messageTemp = ``;

            chatInput.val("");
          },

          error: function (err) {
            console.log("SEND MESSAGE POST REQUEST ERROR");
            console.log(err);
          }
        })
      }
    </script>

  </body>
</html>
